# Sequencer Options

{% hint style="info" %}
This documentation is currently being updated. Please check back later for the latest version.
{% endhint %}

## Overview

The default DePIN configuration provided with the W3bstream release offers the essential stack needed to stream data messages from a DePIN device and process them in W3bstream, generating a validity proof that can be written and verified on-chain.

The Sequencer service provided in this configuration is a reference implementation for a DePIN data sequencer, supporting both [ioID](/depin/builders/reference-docs/ioctl-client/ioid-identities.md) and W3bstream. While suitable for development purposes, this demo service however is best used as a reference or starting point for your own sequencer implementation.

Below, we explore some configuration options for the data sequencer that can be useful during development of your W3bstream project.

## **Data Aggregation**

In a DePIN application, the data sequencer, whether centralized or decentralized, typically authenticates devices, validates, filters, and sorts their data. Each data message processed by the Sequencer is usually appended to a *W3bstream Task* until the expected "aggregation value" is reached. In the provided demo sequencer, the default aggregation value is set to `1`, meaning each message sent to the sequencer is immediately wrapped in a W3bstream Task, stored in the Postgres DB, and fetched by W3bstream for processing.

You can change the data aggregation amount in the Sequencer configuration of `docker-compose.yaml` like shown below:

```yaml
# ...
sequencer:
  # ...
  command: 
    - "coordinatorAddress"
    - "coordinator:9001"
    - "databaseDSN"
    - "postgres://test_user:test_passwd@postgres:5432/test?sslmode=disable"
    - "aggregationAmount"
    - "10" # Increase this value to aggregate more messages in a W3bstream Task
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.iotex.io/depin/iotex-depin-modules/w3bstream/build-with-w3bstream/get-started/sequencer-options.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
